/**
 * Block
 * 
 * @author Taylor Born
 * @version May 2013
 */
public class Block 
{
    private static final SoundCluster HIT_SOUND = new SoundCluster("Hit.wav", 85);

    protected int x, y;
    private boolean destroyed;
    private int transparency;

    public Block(int x, int y, boolean destroyed)
    {
        this.x = x;
        this.y = y;
        this.destroyed = destroyed;
        if (!destroyed)
            transparency = 255;
    }
    public Block(int x, int y)
    {
        this(x, y, false);
    }
    public int getX()
    {
        return x;
    }
    public int getY()
    {
        return y;
    }
    public void getHit()
    {
        playSound();
        destroyed = true;
    }
    public boolean isDestroyed()
    {
        return destroyed;
    }
    public boolean isFading()
    {
        return destroyed && transparency > 0;
    }
    public int getTransparency()
    {
        transparency -= 15;
        return transparency;
    }
    protected void playSound()
    {
        if (x % 2 == 0)
            getSound().play();
    }
    protected SoundCluster getSound()
    {
        return HIT_SOUND;
    }
    public int getWallType()
    {
        return 3;
    }
}