/**
 * Pickup
 * 
 * @author Taylor Born
 * @version June 2013
 */
public class Pickup 
{
    public static final int POWER_TYPE = 0;
    public static final int LIFE_TYPE = 1;
    public static final int SPEED_UP_TYPE = 2;
    public static final int SPEED_DOWN_TYPE = 3;
    public static final int BARRIER_TYPE = 4;
    public static final int SPLIT_TYPE = 5;
    public static final int INCREASE_PADDLE_TYPE = 6;
    public static final int DECREASE_PADDLE_TYPE = 7;
    
    private static final double DROP_CHANCE = 0.2;
    private static final int NUMBER_OF_TYPES = 8;
    
    public static boolean rollForDrop()
    {
        return Math.random() < DROP_CHANCE;
    }
    public static Pickup newPickup(int x, int y)
    {
        int type = (int)(Math.random() * (NUMBER_OF_TYPES - 1 + Power.NUMBER_OF_POWERS));
        if (type >= NUMBER_OF_TYPES - 1)
            return new Power(x, y);
        return new Pickup(x, y, 1 + type);
    }

    private int x, y;
    private int type;

    public Pickup(int x, int y, int type)
    {
        this.x = x;
        this.y = y;
        this.type = type;
    }
    public int getX()
    {
        return x;
    }
    public int getY()
    {
        return y;
    }
    public void act()
    {
        y++;
    }
    public int getType()
    {
        return type;
    }
    public void apply()
    {
        switch (type)
        {
            case LIFE_TYPE:             Screen.main.addLife(); break;
            case SPEED_UP_TYPE:         Screen.main.speedUp(); break;
            case SPEED_DOWN_TYPE:       Screen.main.speedDown(); break;
            case BARRIER_TYPE:          Screen.main.addBarrier(); break;
            case SPLIT_TYPE:            Screen.main.splitBall(); break;
            case INCREASE_PADDLE_TYPE:  Screen.main.increasePaddle(); break;
            case DECREASE_PADDLE_TYPE:  Screen.main.decreasePaddle();
        }
    }
}